<?php
// создание маршрута
add_action( 'rest_api_init', function(){


 
	// пространство имен
	$namespace = 'webalan/v1';

	// маршрут
	$rout = '/author-posts/(?P<id>\d+)';

	// параметры конечной точки (маршрута)
	$rout_params = [
		'methods'  => 'GET',
		'callback' => 'my_awesome_func',
		'args'     => [
			'arg_str' => [
				'type'     => 'string', // значение параметра должно быть строкой
				'required' => true,     // параметр обязательный
			],
			'arg_int' => [
				'type'    => 'integer', // значение параметра должно быть числом
				'default' => 10,        // значение по умолчанию = 10
			],
		],
		'permission_callback' => function( $request ){
			// только авторизованный юзер имеет доступ к эндпоинту
			return is_user_logged_in();
		},
	];

	register_rest_route( $namespace, $rout, $rout_params );

} );

// функция обработчик конечной точки (маршрута)
function my_awesome_func( WP_REST_Request $request ){

	$posts = get_posts( [
		'author' => (int) $request['id'],
	] );

	if ( empty( $posts ) ) {
		return new WP_Error( 'no_author_posts', 'Записей не найдено', [ 'status' => 404 ] );
	}

	return $posts;
}