<?php

define('D_IDB', true);

class d_db extends wpdb
{
  public function __construct()
  {
    parent::__construct(DB_USER, DB_PASSWORD, DB_NAME, DB_HOST);
  }


  public function query($query)
  {
    // купируем запросы
    if((DB_CROP_POSTMETA && stripos($query, 'wp_postmeta')) || (DB_CROP_COMMENTS && (stripos($query, 'wp_comments') || stripos($query, 'wp_commentmeta'))) || (DB_CROP_LINKS && stripos($query, 'wp_links')))
    {
      $this->last_result = array();
      return count($this->last_result);
    }

    // только для SELECT запросов
    if(CACHE_DB && stripos($query, 'SELECT') && (/*stripos($query, 'wp_options') ||*/ stripos($query, 'wp_users') || stripos($query, 'wp_usermeta')) && !is_admin() && !d_is_wp_login_page() && !stripos($query, 'FOUND_ROWS') && !stripos($query, 'rnd404_') && !stripos($query, '_transient'))
    {
      // определяем идентификатор запроса
      $query_id = 'DBCACHE_'.md5(DOMAIN_ID).'_'.strtoupper(d_regex_replace('/\W+/s', '_', trim($query)));

      // пытаемся найти кэш
      if(defined($query_id))
      {
        $this->last_result = $this->d_db_unserialize(constant($query_id));
        return count($this->last_result);
      }

      // выполняем запрос к БД
      $result = parent::query($query);

      // если запрос к options
      if(stripos($query, 'wp_options'))
      {
        // удаляем из кэша rnd404 и transient
        foreach($this->last_result as $item_key => $item_value)
        {
          if(stripos($item_value->option_name, '_transient') || stripos($item_value->option_name, 'rnd404_'))
          {
            unset($this->last_result[$item_key]);
          }
        }
      }

      // сохраняем кэш
      d_config::get()->save($query_id, $this->d_db_serialize($this->last_result));

      return $result;
    }

    return parent::query($query);
  }

  private function d_db_serialize($str_unserialized)
  {
    return str_replace(array("\n", "\r"), array('#n#', '#r#'), serialize($str_unserialized));
  }

  private function d_db_unserialize($str_serialized)
  {
    return unserialize(str_replace(array('#n#', '#r#'), array("\n", "\r"), $str_serialized));
  }

}

$GLOBALS['wpdb'] = new d_db();