<?php if ( post_password_required() ) { return; } ?>

<?php if ( have_comments() ) { ?>

	<div class="headline  comments-title" id="comments">Комментарии</div>

	<ol class="comments-list">
		<?php wp_list_comments( 'callback=mytheme_comment' );?>
	</ol>

	<?php if ( get_comment_pages_count() > 1 && get_option( 'page_comments' ) ) { ?>
	<div class="comments-nav">
		<div class="alignleft"><?php previous_comments_link() ?></div>
		<div class="alignright"><?php next_comments_link() ?></div>
	</div>
	<?php } ?>

<?php } ?>


<?php if ( comments_open() ) { ?>

	<?php do_action( 'comment_form_before' ); ?>

	<div class="respond" id="respond">

		<div class="headline">Добавить комментарий</div>

		<div class="respond__cancel"><?php cancel_comment_reply_link() ?></div>

	<?php if ( get_option( 'comment_registration' ) && !is_user_logged_in() ) { ?>
		<p><?php printf( 'Вам нужно <a href="%s">войти</a>, чтобы оставить комментарий.', wp_login_url( apply_filters( 'the_permalink', get_permalink() ) ) ); ?></p>
		<?php do_action( 'comment_form_must_log_in_after' ); ?>
	<?php } else { ?>

		<form class="form  comment-form" action="<?php echo site_url( '/wp-comments-post.php' ); ?>" method="post">
			<?php do_action( 'comment_form_top' ); ?>

		<?php if ( is_user_logged_in() ) { ?>

			<p><?php printf( __( 'Вы вошли как <a href="%1$s">%2$s</a>. <a href="%3$s" title="Выйти из этой учётной записи">Выйти &raquo;</a>' ), admin_url( 'profile.php' ), $user_identity, wp_logout_url( apply_filters( 'the_permalink', get_permalink() ) ) ); ?></p>
			<?php do_action( 'comment_form_logged_in_after' ); ?>

		<?php } ?>

		<?php if ( ! is_user_logged_in() ) { ?>

			<?php do_action( 'comment_form_before_fields' ); ?>

			<div class="form-row">
				<div class="form-row__field"><input class="form__field  comment-form__field  comment-form__author" type="text" name="author" placeholder="Ваше имя" value="<?php echo $comment_author; ?>"<?php if ($req) echo ' required'; ?> /></div>
				<div class="form-row__field"><input class="form__field  comment-form__field  comment-form__email" type="email" name="email" placeholder="Контактная почта" value="<?php echo $comment_author_email; ?>"<?php if ($req) echo ' required'; ?> /></div>
			</div><!-- .form-row -->

			<?php do_action( 'comment_form_after_fields' ); ?>

		<?php } ?>

			<textarea class="form__field  comment-form__field  comment-form__comment" name="comment" id="comment" rows="4" placeholder="Ваш комментарий" required></textarea>
			<?php do_action( 'comment_form' ); ?>

			<button class="form__button  comment-form__button" name="submit" type="submit">Добавить комментарий</button>

			<?php comment_id_fields(); ?>
		</form>

	<?php } ?>

	</div><!-- .respond -->

	<?php do_action( 'comment_form_after' ); ?>

<?php } ?>