<?php
remove_action('wp_head', 'rsd_link');
remove_action('wp_head', 'wp_generator');
remove_action('wp_head', 'feed_links', 2);
remove_action('wp_head', 'rel_canonical');
remove_action('wp_head', 'index_rel_link');
remove_action('wp_head', 'wlwmanifest_link');
remove_action('wp_head', 'feed_links_extra', 3);
remove_action('wp_head', 'wp_shortlink_wp_head');
remove_action('wp_head', 'start_post_rel_link', 10, 0);
remove_action('wp_head', 'parent_post_rel_link', 10, 0);
remove_action('wp_head', 'adjacent_posts_rel_link', 10, 0);
remove_action('wp_head', 'adjacent_posts_rel_link_wp_head', 10, 0);
remove_action('wp_head', 'print_emoji_detection_script', 7);
remove_action('wp_print_styles', 'print_emoji_styles');
remove_action('admin_print_scripts', 'print_emoji_detection_script');
remove_action('admin_print_styles', 'print_emoji_styles');


// подключаем css-файлы и js-файлы
add_action( 'wp_enqueue_scripts', 'load_theme_css_js' );
function load_theme_css_js() {
	wp_register_style( 'google-fonts', add_query_arg(
		array(
			'family' => 'Montserrat:300,400,400i,500,600,700',
			'subset' => 'cyrillic',
		),
		'//fonts.googleapis.com/css'
	), array(), null );
	wp_enqueue_style( 'google-fonts' );
	// =====
	wp_register_style( 'style.css', get_stylesheet_uri(), false, 1.1 );

 


	 wp_enqueue_style( 'style.css' ); 
	// =====
	wp_enqueue_script( 'jquery' );
	// =====
	if ( is_home() || is_front_page() ) {
		wp_register_script('slick', '//cdn.jsdelivr.net/npm/slick-carousel@1.8.1', array('jquery'), null, true);
		wp_enqueue_script('slick');
	}
	// =====
	wp_register_script( 'scripts.js', get_bloginfo('template_url').'/js/scripts.js', array('jquery'), null, true );
	wp_enqueue_script( 'scripts.js' );
	// =====
	if ( is_singular() && comments_open() && ( get_option('thread_comments')  == 1 ) ) {
		wp_enqueue_script( 'comment-reply' );
	}
}


/* ======================================================
	 Carbon Fields
	 ====================================================== */
add_action( 'after_setup_theme', 'crb_load' );
function crb_load() {
	require_once 'includes/carbon-fields/vendor/autoload.php';
	\Carbon_Fields\Carbon_Fields::boot();
}
add_action( 'carbon_fields_register_fields', 'crb_attach_custom_fields' );
function crb_attach_custom_fields() {

	// подключение меню "Настройки темы"
	require_once 'includes/crb_theme-options.php';

	// подключение метаполей для меню
	require_once 'includes/_crb_nav-menu.php';

	// подключение метаполей для постов
	require_once 'includes/_crb_post-meta.php';

}
/* === end Carbon Fields === */


// меню
register_nav_menu( 'tnav-1', 'Верхнее меню (над поиском)' );
register_nav_menu( 'tnav-2', 'Верхнее меню (основное)' );
register_nav_menu( 'bnav', 'Нижнее меню' );

 
// миниатюры
require_once 'includes/kama_thumbnail.php';



require_once 'includes/item_thumbnail.php';



add_theme_support( 'post-thumbnails' );
/*
item_thumb(array(
	'width' => 250,
	'height' => 150,
	'adaptive' => array(
		array(
			'max-width' => 767,
			'width' => 442,
			'height' => 250,
		),
	)
));
*/


// склонение после числительных
function plural_form( $number, $text, $before = '', $after = '' ) {
	$cases = array ( 2, 0, 1, 1, 1, 2 );
	echo $before . $number . $after .' '. $text[ ( $number % 100 > 4 && $number % 100 < 20 ) ? 2 : $cases[ min( $number % 10, 5 ) ] ];
}
/* вывод
plural_form(
	get_comments_number(),
	// варианты написания для количества 1, 2 и 5
	array('комментарий','комментария','комментариев')
);
*/


// количество просмотров
function get_post_views( $postID ) {
	$count_key = 'post_views_count';
	$count = get_post_meta( $postID, $count_key, true );
	if ( $count == '' ) {
		delete_post_meta( $postID, $count_key );
		add_post_meta( $postID, $count_key, '0' );
		return '0';
	}
	return $count;
}
// echo get_post_views( get_the_ID() );
function set_post_views( $postID ) {
	$count_key = 'post_views_count';
	$count = get_post_meta( $postID, $count_key, true );
	if ( $count == '' ) {
		delete_post_meta( $postID, $count_key );
		add_post_meta( $postID, $count_key, '1' );
	} else {
		$count++;
		update_post_meta( $postID, $count_key, $count );
	}
}


// оборачиваем таблицы в статье тегом для адаптива
function adaptive_table( $content ) {
	$content = preg_replace( '#(<table[^>]*>.*?</table>)#s', '<div class="post__table">$1</div>', $content );
	return $content;
}
add_filter( 'the_content', 'adaptive_table', 100 );


// оборачиваем видео в статье тегом для адаптива
function adaptive_video( $content ) {
	$content = preg_replace( '#(<iframe[^>].*</iframe>)#', '<div class="post__video">$1</div>', $content );
	return $content;
}
add_filter( 'the_content', 'adaptive_video' );


// отключаем стили YARPP
add_action( 'wp_print_styles','lm_dequeue_header_styles' );
function lm_dequeue_header_styles() { wp_dequeue_style('yarppWidgetCss'); }
add_action( 'wp_footer','lm_dequeue_footer_styles' );
function lm_dequeue_footer_styles() { wp_dequeue_style('yarppRelatedCss'); }


// отключаем CSS галереи
add_filter( 'use_default_gallery_style', '__return_false' );


// виджеты
function my_widgets_init() {
	register_sidebar(array(
		'name'          => 'Реклама в рубрике',
		'id'            => 'category',
		'description'   => '',
		'before_widget' => '<div class="category-widget">',
		'after_widget'  => '</div><!-- .category-widget -->',
		'before_title'  => '<!-- ',
		'after_title'   => ' -->',
	));
	register_sidebar(array(
		'name'          => 'Реклама в сайдбаре',
		'id'            => 'sidebar',
		'description'   => '',
		'before_widget' => '<div class="sidebar__section  sidebar__widget">',
		'after_widget'  => '</div><!-- .sidebar__section -->',
		'before_title'  => '<!-- ',
		'after_title'   => ' -->',
	));
	register_sidebar(array(
		'name'          => 'Реклама справа от содержания статьи',
		'id'            => 'toc-widget',
		'description'   => '',
		'before_widget' => '<div class="toc-item">',
		'after_widget'  => '</div><!-- .toc-item -->',
		'before_title'  => '<!-- ',
		'after_title'   => ' -->',
	));
	register_sidebar(array(
		'name'          => 'Реклама справа от комментариев',
		'id'            => 'comments',
		'description'   => '',
		'before_widget' => '<div class="comments-widget">',
		'after_widget'  => '</div><!-- .comments-widget -->',
		'before_title'  => '<!-- ',
		'after_title'   => ' -->',
	));
}
add_action( 'widgets_init', 'my_widgets_init' );


// отключаем автовставку тега <p> в текстовых виджетах
remove_filter('widget_text_content', 'wpautop');


// возможность использования тегов в описании рубрики:
remove_filter( 'pre_term_description', 'wp_filter_kses' );


// отключаем стили  WP-PageNavi
function deregister_wp_pagenavi() { wp_deregister_style( 'wp-pagenavi' ); }
add_action( 'wp_print_styles', 'deregister_wp_pagenavi', 100 );


// шаблон комментария
function mytheme_comment( $comment, $args, $depth ) {
	$GLOBALS['comment'] = $comment; ?>
<li id="comment-<?php comment_ID() ?>">
	<div id="div-comment-<?php comment_ID(); ?>" <?php comment_class(); ?>>

		<?php echo get_avatar( $comment, $size = '60', $default = '' ); ?>

		<div class="comment__meta">

			<span class="comment__author"><?php comment_author(); ?></span>

		<?php if ( comments_open() && ( get_option('thread_comments') == 1 ) && ( $depth != $args['max_depth']) ) { ?>
			<button class="comment__reply" onclick="return addComment.moveForm( 'div-comment-<?php comment_ID(); ?>', <?php comment_ID(); ?>, 'respond', <?php echo get_the_ID(); ?> )">Ответить</button>
		<?php } ?>

			<?php edit_comment_link( __('Edit'),'&nbsp;&nbsp; [ ',' ]' ) ?>

		</div><!-- .comment__meta -->

		<div class="comment__text">
		<?php if ( $comment->comment_approved == '0' ) { ?>
			<p><em><?php _e('Your comment is awaiting moderation.') ?></em></p>
		<?php } ?>
			<?php comment_text() ?>
		</div><!-- .comment__text -->

	</div><!-- .comment -->
<?php
}


// удаляем класс "photo" из аватара
add_filter( 'get_avatar', 'change_avatar_classes' );
function change_avatar_classes($class) {
	$class = str_replace(' photo', '', $class);
	return $class;
}


/*
 * "Хлебные крошки" для WordPress
 * автор: Dimox
 * версия: 2016.11.17
 * лицензия: MIT
*/
function dimox_breadcrumbs() {

	/* === ОПЦИИ === */
	$text['home']     = 'Главная'; // текст ссылки "Главная"
	$text['category'] = '%s'; // текст для страницы рубрики
	$text['search']   = 'Результаты поиска по запросу "%s"'; // текст для страницы с результатами поиска
	$text['tag']      = 'Записи с тегом "%s"'; // текст для страницы тега
	$text['author']   = 'Статьи автора %s'; // текст для страницы автора
	$text['404']      = 'Ошибка 404'; // текст для страницы 404
	$text['page']     = 'Страница %s'; // текст 'Страница N'
	$text['cpage']    = 'Страница комментариев %s'; // текст 'Страница комментариев N'

	$wrap_before    = '<div class="breadcrumbs" itemscope itemtype="http://schema.org/BreadcrumbList">'; // открывающий тег обертки
	$wrap_after     = '</div><!-- .breadcrumbs -->'; // закрывающий тег обертки
	$sep            = '›'; // разделитель между "крошками"
	$sep_before     = '<span class="sep">'; // тег перед разделителем
	$sep_after      = '</span>'; // тег после разделителя
	$show_home_link = 1; // 1 - показывать ссылку "Главная", 0 - не показывать
	$show_on_home   = 0; // 1 - показывать "хлебные крошки" на главной странице, 0 - не показывать
	$show_current   = 0; // 1 - показывать название текущей страницы, 0 - не показывать
	$before         = '<span class="current">'; // тег перед текущей "крошкой"
	$after          = '</span>'; // тег после текущей "крошки"
	/* === КОНЕЦ ОПЦИЙ === */

	global $post;
	$home_url       = home_url('/');
	$link_before    = '<span itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">';
	$link_after     = '</span>';
	$link_attr      = ' itemprop="item"';
	$link_in_before = '<span itemprop="name">';
	$link_in_after  = '</span>';
	$link           = $link_before . '<a href="%1$s"' . $link_attr . '>' . $link_in_before . '%2$s' . $link_in_after . '</a>' . $link_after;
	$frontpage_id   = get_option('page_on_front');
	$parent_id      = ($post) ? $post->post_parent : '';
	$sep            = ' ' . $sep_before . $sep . $sep_after . ' ';
	$home_link      = $link_before . '<a href="' . $home_url . '"' . $link_attr . ' class="home">' . $link_in_before . $text['home'] . $link_in_after . '</a>' . $link_after;

	if (is_home() || is_front_page()) {

		if ($show_on_home) echo $wrap_before . $home_link . $wrap_after;

	} else {

		echo $wrap_before;
		if ($show_home_link) echo $home_link;

		if ( is_category() ) {
			$cat = get_category(get_query_var('cat'), false);
			if ($cat->parent != 0) {
				$cats = get_category_parents($cat->parent, TRUE, $sep);
				$cats = preg_replace("#^(.+)$sep$#", "$1", $cats);
				$cats = preg_replace('#<a([^>]+)>([^<]+)<\/a>#', $link_before . '<a$1' . $link_attr .'>' . $link_in_before . '$2' . $link_in_after .'</a>' . $link_after, $cats);
				if ($show_home_link) echo $sep;
				echo $cats;
			}
			if ( get_query_var('paged') ) {
				$cat = $cat->cat_ID;
				echo $sep . sprintf($link, get_category_link($cat), get_cat_name($cat)) . $sep . $before . sprintf($text['page'], get_query_var('paged')) . $after;
			} else {
				echo $sep . $before . sprintf($text['category'], single_cat_title('', false)) . $after;
			}

		} elseif ( is_search() ) {
			if (have_posts()) {
				if ($show_home_link && $show_current) echo $sep;
				if ($show_current) echo $before . sprintf($text['search'], get_search_query()) . $after;
			} else {
				if ($show_home_link) echo $sep;
				echo $before . sprintf($text['search'], get_search_query()) . $after;
			}

		} elseif ( is_day() ) {
			if ($show_home_link) echo $sep;
			echo sprintf($link, get_year_link(get_the_time('Y')), get_the_time('Y')) . $sep;
			echo sprintf($link, get_month_link(get_the_time('Y'), get_the_time('m')), get_the_time('F'));
			if ($show_current) echo $sep . $before . get_the_time('d') . $after;

		} elseif ( is_month() ) {
			if ($show_home_link) echo $sep;
			echo sprintf($link, get_year_link(get_the_time('Y')), get_the_time('Y'));
			if ($show_current) echo $sep . $before . get_the_time('F') . $after;

		} elseif ( is_year() ) {
			if ($show_home_link && $show_current) echo $sep;
			if ($show_current) echo $before . get_the_time('Y') . $after;

		} elseif ( is_single() && !is_attachment() ) {
			if ($show_home_link) echo $sep;
			if ( get_post_type() != 'post' ) {
				$post_type = get_post_type_object(get_post_type());
				$slug = $post_type->rewrite;
				printf($link, $home_url . $slug['slug'] . '/', $post_type->labels->singular_name);
				if ($show_current) echo $sep . $before . get_the_title() . $after;
			} else {
				$cat = get_the_category(); $cat = $cat[0];
				$cats = get_category_parents($cat, TRUE, $sep);
				if (!$show_current || get_query_var('cpage')) $cats = preg_replace("#^(.+)$sep$#", "$1", $cats);
				$cats = preg_replace('#<a([^>]+)>([^<]+)<\/a>#', $link_before . '<a$1' . $link_attr .'>' . $link_in_before . '$2' . $link_in_after .'</a>' . $link_after, $cats);
				echo $cats;
				if ( get_query_var('cpage') ) {
					echo $sep . sprintf($link, get_permalink(), get_the_title()) . $sep . $before . sprintf($text['cpage'], get_query_var('cpage')) . $after;
				} else {
					if ($show_current) echo $before . get_the_title() . $after;
				}
			}

		// custom post type
		} elseif ( !is_single() && !is_page() && get_post_type() != 'post' && !is_404() ) {
			$post_type = get_post_type_object(get_post_type());
			if ( get_query_var('paged') ) {
				echo $sep . sprintf($link, get_post_type_archive_link($post_type->name), $post_type->label) . $sep . $before . sprintf($text['page'], get_query_var('paged')) . $after;
			} else {
				if ($show_current) echo $sep . $before . $post_type->label . $after;
			}

		} elseif ( is_attachment() ) {
			if ($show_home_link) echo $sep;
			$parent = get_post($parent_id);
			$cat = get_the_category($parent->ID); $cat = $cat[0];
			if ($cat) {
				$cats = get_category_parents($cat, TRUE, $sep);
				$cats = preg_replace('#<a([^>]+)>([^<]+)<\/a>#', $link_before . '<a$1' . $link_attr .'>' . $link_in_before . '$2' . $link_in_after .'</a>' . $link_after, $cats);
				echo $cats;
			}
			printf($link, get_permalink($parent), $parent->post_title);
			if ($show_current) echo $sep . $before . get_the_title() . $after;

		} elseif ( is_page() && !$parent_id ) {
			if ($show_current) echo $sep . $before . get_the_title() . $after;

		} elseif ( is_page() && $parent_id ) {
			if ($show_home_link) echo $sep;
			if ($parent_id != $frontpage_id) {
				$breadcrumbs = array();
				while ($parent_id) {
					$page = get_page($parent_id);
					if ($parent_id != $frontpage_id) {
						$breadcrumbs[] = sprintf($link, get_permalink($page->ID), get_the_title($page->ID));
					}
					$parent_id = $page->post_parent;
				}
				$breadcrumbs = array_reverse($breadcrumbs);
				for ($i = 0; $i < count($breadcrumbs); $i++) {
					echo $breadcrumbs[$i];
					if ($i != count($breadcrumbs)-1) echo $sep;
				}
			}
			if ($show_current) echo $sep . $before . get_the_title() . $after;

		} elseif ( is_tag() ) {
			if ( get_query_var('paged') ) {
				$tag_id = get_queried_object_id();
				$tag = get_tag($tag_id);
				echo $sep . sprintf($link, get_tag_link($tag_id), $tag->name) . $sep . $before . sprintf($text['page'], get_query_var('paged')) . $after;
			} else {
				if ($show_current) echo $sep . $before . sprintf($text['tag'], single_tag_title('', false)) . $after;
			}

		} elseif ( is_author() ) {
			global $author;
			$author = get_userdata($author);
			if ( get_query_var('paged') ) {
				if ($show_home_link) echo $sep;
				echo sprintf($link, get_author_posts_url($author->ID), $author->display_name) . $sep . $before . sprintf($text['page'], get_query_var('paged')) . $after;
			} else {
				if ($show_home_link && $show_current) echo $sep;
				if ($show_current) echo $before . sprintf($text['author'], $author->display_name) . $after;
			}

		} elseif ( is_404() ) {
			if ($show_home_link && $show_current) echo $sep;
			if ($show_current) echo $before . $text['404'] . $after;

		} elseif ( has_post_format() && !is_singular() ) {
			if ($show_home_link) echo $sep;
			echo get_post_format_string( get_post_format() );
		}

		echo $wrap_after;

	}
} // end of dimox_breadcrumbs()


// удаляем лишние отступы у изображений с подписью
add_filter( 'img_caption_shortcode', 'my_img_caption_shortcode', 10, 3 );
function my_img_caption_shortcode( $empty, $attr, $content ){
	$attr = shortcode_atts( array(
		'id'      => '',
		'align'   => 'alignnone',
		'width'   => '',
		'caption' => ''
	), $attr );
	if ( 1 > (int) $attr['width'] || empty( $attr['caption'] ) ) { return ''; }
	if ( $attr['id'] ) { $attr['id'] = 'id="' . esc_attr( $attr['id'] ) . '" '; }
	return '<div ' . $attr['id']
	. 'class="wp-caption ' . esc_attr( $attr['align'] ) . '" '
	. 'style="max-width: ' . ( (int) $attr['width'] ) . 'px;">'
	. do_shortcode( $content )
	. '<div class="wp-caption-text">' . $attr['caption'] . '</div>'
	. '</div>';
}


// добавляем иконки в меню
function wp_nav_menu_item_icon( $output, $item, $depth, $args ) {
	if ( $args->theme_location == 'tnav-2' ) {
		$image_ID = carbon_get_nav_menu_item_meta( $item->ID, 'menu_icon' );
		if ( $image_ID ) {
			$src = wp_get_attachment_url( $image_ID );
			if ( $src ) {
				$output = preg_replace( '#(<a[^>]*>)(.*)(<\/a>)#', '$1<div class="header__nav-2-icon"><img src="'. $src .'" alt="" /></div>$2$3', $output );
			}
		}
	}
	return $output;
}
add_action( 'walker_nav_menu_start_el', 'wp_nav_menu_item_icon', 10, 4 );


// обертка для Table of Contents Plus + виджет
add_filter('the_content', 'toc_plus_wrapper', 1000);
function toc_plus_wrapper($content) {
	ob_start();
	dynamic_sidebar('toc-widget');
	$toc_widget = ob_get_contents();
	ob_end_clean();
	return preg_replace('#(<div id="toc_container"[^>]+>(.*)</li></ul></div>)#', '<div class="toc-wrapper"><div class="toc-item"><!--noindex-->$1<!--/noindex--></div><!-- .toc-item -->' . $toc_widget . '</div><!-- .toc-wrapper -->', $content);
}

//Загрузка/отключение скриптов/стилей
function add_styles_scripts(){
	//Jquery
    wp_deregister_script('jquery-core');
    wp_register_script('jquery-core', '//ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js');
   // wp_enqueue_script('jquery');
}
add_action( 'wp_enqueue_scripts', 'add_styles_scripts' );

remove_action('wp_head', 'rsd_link');
remove_action('wp_head', 'wp_generator');
remove_action('wp_head', 'feed_links', 2);
remove_action('wp_head', 'rel_canonical');
remove_action('wp_head', 'index_rel_link');
remove_action('wp_head', 'wlwmanifest_link');
remove_action('wp_head', 'feed_links_extra', 3);
remove_action('wp_head', 'wp_shortlink_wp_head');
remove_action('wp_head', 'start_post_rel_link', 10, 0);
remove_action('wp_head', 'parent_post_rel_link', 10, 0);
remove_action('wp_head', 'adjacent_posts_rel_link', 10, 0);
remove_action('wp_head', 'adjacent_posts_rel_link_wp_head', 10, 0);

// Отключаем сам REST API
add_filter('rest_enabled', '__return_false');
// Отключаем фильтры REST API
remove_action( 'xmlrpc_rsd_apis',            'rest_output_rsd' );
remove_action( 'wp_head',                    'rest_output_link_wp_head', 10, 0 );
remove_action( 'template_redirect',          'rest_output_link_header', 11, 0 );
remove_action( 'auth_cookie_malformed',      'rest_cookie_collect_status' );
remove_action( 'auth_cookie_expired',        'rest_cookie_collect_status' );
remove_action( 'auth_cookie_bad_username',   'rest_cookie_collect_status' );
remove_action( 'auth_cookie_bad_hash',       'rest_cookie_collect_status' );
remove_action( 'auth_cookie_valid',          'rest_cookie_collect_status' );
remove_filter( 'rest_authentication_errors', 'rest_cookie_check_errors', 100 );
// Отключаем события REST API
remove_action( 'init',          'rest_api_init' );
remove_action( 'rest_api_init', 'rest_api_default_filters', 10, 1 );
remove_action( 'parse_request', 'rest_api_loaded' );
// Отключаем Embeds связанные с REST API
remove_action( 'rest_api_init',          'wp_oembed_register_route'              );
remove_filter( 'rest_pre_serve_request', '_oembed_rest_pre_serve_request', 10, 4 );
remove_action( 'wp_head', 'wp_oembed_add_discovery_links' );
remove_action( 'wp_head', 'wp_oembed_add_host_js' );
// Отключаем Emoji
remove_action( 'wp_head', 'print_emoji_detection_script', 7 );
remove_action( 'wp_print_styles', 'print_emoji_styles' );
remove_action( 'admin_print_scripts', 'print_emoji_detection_script' );
remove_action( 'admin_print_styles', 'print_emoji_styles' );

//Отключаем RSS
add_action('do_feed', 'morkovin_fb_disable_feed', 1);
add_action('do_feed_rdf', 'morkovin_fb_disable_feed', 1);
add_action('do_feed_rss', 'morkovin_fb_disable_feed', 1);
add_action('do_feed_rss2', 'morkovin_fb_disable_feed', 1);
add_action('do_feed_atom', 'morkovin_fb_disable_feed', 1);
function morkovin_fb_disable_feed() {
    wp_die( __('No feed available,please visit our <a href="'. get_bloginfo('url') .'">homepage</a>!') );
}

//Отключаем Pingback
add_filter( 'xmlrpc_methods', 'morkovin_sar_block_xmlrpc_attacks' );
function morkovin_sar_block_xmlrpc_attacks( $methods ) {
   unset( $methods['pingback.ping'] );
   unset( $methods['pingback.extensions.getPingbacks'] );
   return $methods;
}
add_filter( 'wp_headers', 'morkovin_sar_remove_x_pingback_header' );
function morkovin_sar_remove_x_pingback_header( $headers ) {
   unset( $headers['X-Pingback'] );
   return $headers;
}

//Отключаем srcset и sizes для картинок в WordPress
add_filter('wp_calculate_image_srcset_meta', '__return_null' );
add_filter('wp_calculate_image_sizes', '__return_false', 99 );
remove_filter('the_content', 'wp_make_content_images_responsive' );
add_filter('wp_get_attachment_image_attributes', 'unset_attach_srcset_attr', 99 );
function unset_attach_srcset_attr( $attr ){
foreach( array('sizes','srcset') as $key )
    if( isset($attr[ $key ]) ) unset($attr[ $key ]);
    return $attr;
}

//noindex для toc+
add_filter( 'the_content', 'morkovin_noindex_toc', 1000);
function morkovin_noindex_toc($content){
 return preg_replace('/(<div id="toc_container"[^>]+>[^\n]+)/', '<!--noindex-->$1<!--/noindex-->', $content);
}

//убираем в комментариях поля Сайт и Email? а Имя делаем обязательным
function remove_comment_fields($fields) {
unset($fields['url']);
unset($fields['email']);
return $fields;
}
add_filter('comment_form_default_fields', 'remove_comment_fields');
function custom_validate_comment_author() {

//webalan
if (empty($_POST['author']))
{
	$current_user = wp_get_current_user();
	if ($current_user->ID == 0)
		$_POST['author'] = $_REQUEST['author'] = 'Гость';
	else
     $_POST['author'] = $_REQUEST['author'] = $current_user->display_name;
}


 

    if( empty( $_POST['author'] ) || ( !preg_match( '/[^\s]/', $_POST['author'] ) ) )
        wp_die( __('Ошибка! Пожалуйста, заполните поле Имя') );
}
add_action( 'pre_comment_on_post', 'custom_validate_comment_author' );

// Убираем из индекса page/2/3/4
add_action( 'wp_head', 'noindex_paged', 2 );

function noindex_paged() {
 if ( is_paged() ) {
 echo '<meta name="robots" content="noindex,nofollow"/>';
 }
}
//Вывод первой картинки с поста
function first_post_image() {
global $post, $posts;
$first_img = '';
ob_start();
ob_end_clean();
$output = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches);
$first_img = isset($matches [1] [0]) ? $matches [1][0] : '';
if(empty($first_img)){
$first_img = "/wp-content/themes/НАЗВАНИЕТЕМЫ/images/noimages.jpg";
// укажите путь к изображению, которое будет выводится по умолчанию.
}
return $first_img;
}

function firstthumb() {
$files = get_children('post_parent='.get_the_ID().'&post_type=attachment&post_mime_type=image');
  if($files) :
    $keys = array_reverse(array_keys($files));
    $j=0;
    $num = $keys[$j];
    $image=wp_get_attachment_image($num, 'large', false);
    $imagepieces = explode('"', $image);
    $imagepath = $imagepieces[1];
    $thumb=wp_get_attachment_thumb_url($num);
    print "<img src='$thumb' class='thumbnail' />";
  endif;
}

