<?php require('header.php') ?>

		<div class="wrap">

		<?php
		$loop = new WP_Query(array(
			'posts_per_page' => 10,
			'cat' => "-$goods",
			'orderby' => 'post_views',
			'meta_query' => array(
				'post_views' => array(
					'key'=> 'post_views_count',
					'value'=> '0',
					'compare'=> '>',
					'type'=> 'NUMERIC',
				),
			),
		)); ?>
		<?php if ( $loop->have_posts() ) { ?>
			<div class="popular">
				<div class="headline">Популярные статьи</div>
				<div class="popular__inner">

					<div class="popular__items">
				<?php while ( $loop->have_posts() ) { $loop->the_post(); ?>
						<div class="popular-item">

							<div class="popular-item__image"><?php
								item_thumb(array(
									'width' => 242,
									'height' => 200,
									'adaptive' => array(
										array(
											'max-width' => 767,
											'width' => 382,
											'height' => 200,
										),
									)
								));
							?></div>

							<div class="popular-item__inner">

								<div class="popular-item__title"><a class="popular-item__link" href="<?php the_permalink() ?>"><?php the_title(); ?></a></div>

								<div class="popular-item__text"><?php echo ( $post->post_excerpt ) ? get_the_excerpt() : wp_trim_words( get_the_excerpt(), 20, ' ...' ) ?></div>

								<div class="popular-item__meta">

									<div class="popular-item__cat"><a href="<?php $cat = get_the_category(); $catID = $cat[0]->cat_ID; echo get_category_link($catID); ?>"><?php echo get_cat_name($catID) ?></a></div>

								<?php
								$rating = get_post_meta( get_the_ID(), 'ratings_average', true );
								if ( $rating > 0 ) { ?>
									<div class="rating  popular-item__rating"><div class="rating__current" style="width: <?php echo $rating * 17 ?>px"></div></div>
								<?php } ?>

									<?php if ( ( $views = get_post_views( get_the_ID() ) ) > 0 ) { ?><div class="popular-item__views"><?php echo number_format($views, 0, '', ' ') ?></div><?php } ?>

								</div><!-- .popular-item__meta -->

							</div><!-- .popular-item__inner -->

						</div><!-- .popular-item -->
				<?php } ?>
					</div><!-- .popular__items -->

					<div class="popular__thumbs">
					<?php while ( $loop->have_posts() ) { $loop->the_post(); ?>
						<div class="popular-thumb">
							<div class="popular-thumb__image"><?php
								item_thumb(array(
									'width' => 153,
									'height' => 110,
								));
							?></div>
							<div class="popular-thumb__title"><?php the_title(); ?></div>
						</div>
					<?php } ?>
					</div><!-- .popular__thumbs -->

				</div><!-- .popular__inner -->
			</div><!-- .popular -->
		<?php } wp_reset_postdata(); ?>

			<?php include '__goods.php'; ?>

		</div><!-- .wrap -->

		<div class="questions">
			<div class="questions__inner">

		<?php if ( $questions ) { ?>
			<?php
			$loop = new WP_Query(array(
				'posts_per_page' => 2,
				'cat' => $questions,
			)); ?>
			<?php if ( $loop->have_posts() ) { ?>
				<div class="questions__recent">
					<div class="headline">Ваши вопросы – наши ответы</div>
					<div class="questions__items">
				<?php while ( $loop->have_posts() ) { $loop->the_post(); ?>
						<?php include '__item-small.php'; ?>
				<?php } ?>
					</div><!-- .questions__items -->
					<div class="questions__all"><a href="<?php echo get_category_link( $questions ); ?>">Смотреть все вопросы и ответы</a></div>
				</div><!-- .questions__recent -->
			<?php } wp_reset_postdata(); ?>
		<?php } ?>

			<?php if ( $questions_image ) {?>
				<div class="questions__image"><img src="<?php echo $questions_image; ?>" alt="" /></div>
			<?php } ?>

				<div class="questions__aside">

					<div class="ask">
						<div class="ask__title">У вас есть свой вопрос?</div>
						<div class="ask__text">Вы всегда можете задать любой интересующий Вас вопрос нашим экспертам и профессиональным ветеринарам</div>
						<button class="ask__button  js-ask-form" data-theme="<?php echo get_template(); ?>">Задать свой вопрос</button>
					</div><!-- .ask -->

					<div class="stats">

						<div class="stats__item  stats__item-1">
							<div class="stats__title">2 865 довольных клиентов</div>
							<div class="stats__text">Столько человек уже получили консультацию и помощь</div>
						</div><!-- .stats__item -->

						<div class="stats__item  stats__item-2">
							<div class="stats__title">26 профессиональных специалистов</div>
							<div class="stats__text">Работают в штате нашей редакции и отвечают на вопросы посетителей</div>
						</div><!-- .stats__item -->

					</div><!-- .stats -->

				</div><!-- .questions__aside -->

			</div><!-- .questions__inner -->
		</div><!-- .questions -->

		<div class="middle">

			<div class="content">

		<?php
		foreach ( $homecats as $category ) {
			$catID = $category['id'];
		?>
			<?php
			$loop = new WP_Query(array(
				'posts_per_page' => 1,
				'cat' => $catID,
			)); ?>
			<?php if ( $loop->have_posts() ) { ?>
				<div class="category">
					<div class="category__head">
						<div class="headline"><?php echo get_cat_name( $catID ); ?></div>
						<a class="category__all" href="<?php echo get_category_link( $catID ); ?>">Смотреть все</a>
					</div><!-- .category__head -->
					<div class="category__inner">

				<?php while ( $loop->have_posts() ) { $loop->the_post(); ?>
					<div class="category__item">

						<div class="category__item-image"><?php
							item_thumb(array(
								'width' => 362,
								'height' => 240,
							));
						?></div>

						<div class="category__item-title"><a class="category__item-link" href="<?php the_permalink() ?>"><?php the_title(); ?></a></div>

						<div class="category__item-text"><?php echo ( $post->post_excerpt ) ? get_the_excerpt() : wp_trim_words( get_the_excerpt(), 15, ' ...' ) ?></div>

					</div><!-- .category__item -->
				<?php } ?>

					<?php
					$loop = new WP_Query(array(
						'posts_per_page' => 5,
						'offset' => 1,
						'cat' => $catID,
					)); ?>
					<?php if ( $loop->have_posts() ) { ?>
						<ul class="category__list">
						<?php while ( $loop->have_posts() ) { $loop->the_post(); ?>
							<li class="category__list-item"><a class="category__list-link" href="<?php the_permalink() ?>"><?php the_title(); ?></a></li>
						<?php } ?>
						</ul><!-- .category__list -->
					<?php } wp_reset_postdata(); ?>

					</div><!-- .category__inner -->
				</div><!-- .category -->
			<?php } wp_reset_postdata(); ?>
		<?php } ?>

			<?php
			$loop = new WP_Query(array(
				'posts_per_page' => 3,
				'cat' => "-$goods,-$questions,-$video",
			)); ?>
			<?php if ( $loop->have_posts() ) { ?>
				<div class="recent">
					<div class="headline">Обновления на сайте</div>
					<div class="items">
				<?php while ( $loop->have_posts() ) { $loop->the_post(); ?>
						<?php include '__item.php'; ?>
				<?php } ?>
					</div><!-- .items -->
				</div><!-- .recent -->
			<?php } wp_reset_postdata(); ?>

			</div><!-- .content -->

			<aside class="sidebar">

				<?php $sidebar = true; ?>
				<?php include '__video.php'; ?>
				<?php include '__vk-widget.php'; ?>

			</aside><!-- .sidebar -->

		</div><!-- .middle -->

<?php if ( $homepage ) { ?>
	<?php $loop = new WP_Query("page_id=$homepage") ?>
	<?php if ( $loop->have_posts() ) { ?>
		<?php while ( $loop->have_posts() ) { $loop->the_post() ?>
		<article class="post  post--home">
			<h1 class="headline"><?php the_title() ?></h1>
			<div class="post__entry">
				<?php the_content() ?>
				<?php edit_post_link('Редактировать', '<p>', '</p>') ?>
			</div><!-- .post__entry -->
		</article><!-- .post -->
		<?php } ?>
	<?php } wp_reset_postdata(); ?>
<?php } ?>

<?php require('footer.php') ?>