<?php
use Carbon_Fields\Container;
use Carbon_Fields\Field;

Container::make( 'theme_options', 'Настройки темы' )
	->set_page_menu_position( 60 )


	->add_tab( 'Основное', array(

		Field::make( 'image', 'logo', 'Логотип' )
			->set_value_type( 'url' )
			->set_width(33)
			->help_text( '<p>Рекомендуемый размер: 65×65 пикселей</p>' )
		,

		Field::make( 'text', 'logo_title_left', 'Заголовок в логотипе (левая часть)' )->set_width(33),
		Field::make( 'text', 'logo_title_right', 'Заголовок в логотипе (правая часть)' )->set_width(33),

		Field::make( 'color', 'header_nav_bg_left', 'Фон основного меню (слева)' )->set_width(25),
		Field::make( 'color', 'header_nav_bg_right', 'Фон основного меню (справа)' )->set_width(25),
		Field::make( 'color', 'header_nav_link_color', 'Цвет ссылки основного меню' )->set_width(25),
		Field::make( 'color', 'header_nav_hover_bg', 'Фон при наведении на ссылку основного меню' )->set_width(25),

	)) // end tab


	->add_tab( 'Страницы', array(

		// страница
		Field::make( 'association',
			'homepage',
			'Выберите страницу, текст которой отобразится на главной'
		)
			->set_types(array(
				array(
					'type' => 'post',
					'post_type' => 'page',
				),
			))
			->set_max(1)
			->help_text( '<p>Для выбора кликните на нужную страницу.</p>' )
		,

		// страница
		Field::make( 'association',
			'privacy',
			'Выберите страницу "Политика конфиденциальности"'
		)
			->set_types(array(
				array(
					'type' => 'post',
					'post_type' => 'page',
				),
			))
			->set_max(1)
			->help_text( '<p>Для выбора кликните на нужную страницу.</p>' )
		,

	)) // end tab
	// Запись
	->add_tab( 'Запись', array(

		Field::make( 'select', 'sidebarsingle', 'Включить сайдбар' )->add_options( array(
        'no' => 'нет',
        'on' => 'да'
    ) ),

	)) // end tab

	->add_tab( 'Социальные сети', array(

		Field::make( 'text', 'social_vk', 'ВКонтакте' )->set_width(50),
		Field::make( 'text', 'social_ok', 'Одноклассники' )->set_width(50),
		Field::make( 'text', 'social_fb', 'Facebook' )->set_width(50),
		Field::make( 'text', 'social_gp', 'Google+' )->set_width(50),

		Field::make( 'text', 'vk_widget', 'ID виджета ВКонтакте' )
			->set_width(50)
			->help_text( '<p>Для получения ID:</p>
				– зайдите на <a href="https://vk.com/dev/Community" target="_blank">эту страницу</a>;<br />
				– укажите ссылку на ваше сообщество в ВК;<br />
				– из кода для вставки скопируйте длинное число (вида 20003922) и вставьте сюда.' )
		,

	)) // end tab


	->add_tab( 'Счетчики', array(

		Field::make( 'textarea', 'counters', 'Счетчики в подвале' )
			->set_width(50)
		,

	)) // end tab


;


add_action( 'admin_head', 'my_custom_css' );
function my_custom_css() { ?>
<style>
#theme-options-form .carbon-field > label {
	font-size: 14px;
	color: #04A4CC !important;
}
#theme-options-form .carbon-association-left .carbon-association-list,
#theme-options-form .carbon-association-right .carbon-association-list {
	height: 174px;
}
/*.carbon-table-row .carbon-container > .carbon-field > label {
	width: 200px;
}*/
</style>
<?php }