<?php

function item_thumb( $args = '' ) {

	$defaults = array(
		'width' => 100,
		'height' => 100,
		'adaptive' => false,
		'src' => false,
		'alt' => get_the_title(),
		'placeholder' => true,
		'echo' => true,
	);
	$arg = wp_parse_args( $args, $defaults );

	$w = $arg['width'];
	$h = $arg['height'];
	$adaptive = $arg['adaptive'];

	$src = '';
	if ( $arg['src'] ) $src = '&src=' . $arg['src'];

	$alt = $arg['alt'];
	$placeholder = $arg['placeholder'];
	$echo = $arg['echo'];

	if ( $w == 'auto' ) {
		$args = "h=$h{$src}";
		$image = kama_thumb_src( $args );
		$attr_width = '';
		$attr_height = ' height="'.$h.'"';
	} elseif ( $h == 'auto' ) {
		$args = "w=$w{$src}";
		$image = kama_thumb_src( $args );
		$attr_width = ' width="'.$w.'"';
		$attr_height = '';
	} else {
		$args = "w=$w&h=$h{$src}";
		$image = kama_thumb_src( $args );
		$attr_width = ' width="'.$w.'"';
		$attr_height = ' height="'.$h.'"';
	}

	$output = '';

	if ( $adaptive ) $output .= '<picture>';

	if ( $image ) {
		if ( $adaptive ) {
			foreach ( $adaptive as $m ) {
				$media_w = $m['width'];
				$media_h = $m['height'];
				$output .= '<source media="('.key($m).': '.current($m).'px)" srcset="'.kama_thumb_src("w=$media_w&h=$media_h").'">';
			}
		}
		$output .= '<img src="'.$image.'"'.$attr_width . $attr_height.' alt="'.$alt.'" />';
	} elseif ( $placeholder ) {
		if ( $adaptive ) {
			foreach ( $adaptive as $m ) {
				$media_w = $m['width'];
				$media_h = $m['height'];
				$output .= '<source media="('.key($m).': '.current($m).'px)" srcset="'.base64img($media_w,$media_h).'">';
			}
		}
		if ( $w == 'auto' ) $w = '200';
		if ( $h == 'auto' ) $h = '100';
		$output .= '<img src="'.base64img($w,$h).'"'.$attr_width . $attr_height.' alt="" />';
	}

	if ( $adaptive ) $output .= '</picture>';

	if ( $echo ) {
		echo $output;
	} else {
		return $output;
	}

}

// прозрачная картинка в base64 на случай отсутствия миниатюры
function createTransparentPng($w = 100, $h = 100) {
	$img = imagecreatetruecolor($w, $h); imagesavealpha($img, true);
	$color = imagecolorallocatealpha($img, 0, 0, 0, 127); imagefill($img, 0, 0, $color);
	ob_start(); imagepng($img); imagedestroy($img);
	return ob_get_clean();
}
function base64img($w = 100, $h = 100) {
	$image = createTransparentPng($w, $h);
	return 'data:image/png;base64,' . base64_encode($image);
}