(function($) {
$(function() {

	/* === Mobile Menu === */
	var menuToggle = 'button.header__menu-toggle';
	var navToMenu = 'div.header__menu';

	if ( $(navToMenu).length ) {
		$(menuToggle).click(function() {
			$('html').addClass('menu-active');
		});

		$('body').append('<div class="menu-overlay"></div><div class="menu"><div class="menu__inner">' + $(navToMenu).html() + '</div></div>');

		var menu = $('div.menu__inner')
			.before('<div class="menu__close"></div>')
			.prepend('<div class="menu__topbar"><div class="menu__back"></div><div class="menu__title"></div></div>')
		;
		$('div.menu-overlay, div.menu__close').click(function() {
			$('html').removeClass('menu-active');
		});

		var topbar = $('div.menu__topbar', menu);
		var back = $('div.menu__back', menu);
		var title = $('div.menu__title', menu);

		menu
			.find('li').removeAttr('class id').end()
			.find('ul')
				.removeAttr('class id')
				.addClass('menu__item')
				.first().addClass('menu__topmenu active').attr('id', 'm-0')
			.find('a:not(:last-child)').each(function(i) {
				i++;
				var link = $(this);
				var submenu = link.next('ul').removeClass('sub-menu').addClass('menu__submenu').attr('id', 'm-' + i);
				var parent = submenu.closest('li').closest('ul').attr('id');
				submenu.data('parent', parent);
				link.after('<div class="menu__show-submenu" data-id="m-' + i + '"></div>');
			})
		;
		menu.find('ul').appendTo(menu);
		menu.find('ul.menu__item:not(.menu__topmenu):not(.menu__submenu)').each(function() {
			menu.find('ul.menu__topmenu').append( $(this).html() );
			$(this).remove();
		});
		menu.find('nav').remove();
		menu
			.on('click', 'div.menu__show-submenu', function() {
				topbar.addClass('active');
				var arrow = $(this);
				arrow.closest('ul').removeClass('active').addClass('hidden');
				var id = arrow.data('id');
				$('#' + id).addClass('active');
				var parent = $('#' + id).data('parent');
				back.data('show', parent).data('hide', id);
				title.text( arrow.siblings('a').text() );
			})
			.on('click', 'div.menu__back', function() {
				var back = $(this);
				var show = back.data('show');
				var hide = back.data('hide');
				if ( show === 'm-0' ) {
					menu.find('ul.menu__topmenu').addClass('active');
					topbar.removeClass('active');
				}
				back.data( 'show', $('#' + show).data('parent') ).data('hide', show);
				title.text( menu.find('[data-id="' + show + '"]').siblings('a').text() );
				$('#' + show).addClass('active').removeClass('hidden');
				$('#' + hide).removeClass('active');
			})
		;
	} // if (navToMenu)
	/* === end of Mobile Menu === */

	if ( $('div.popular__items').length ) {
		$('div.popular__items').slick({
			asNavFor: 'div.popular__thumbs',
			arrows: false,
			fade: true,
			swipe: false,
			adaptiveHeight: true,
		});
	}

	if ( $('div.popular__thumbs').length ) {
		$('div.popular__thumbs').slick({
			asNavFor: 'div.popular__items',
			arrows: false,
			swipe: false,
			autoplay: true,
			autoplaySpeed: 5000,
			slidesToShow: 4,
			focusOnSelect: true,
			responsive: [
				{
					breakpoint: 768,
					settings: {
						slidesToShow: 3,
					}
				},
				{
					breakpoint: 480,
					settings: {
						slidesToShow: 2,
					}
				},
			],
		});
	}

	$('button.js-ask-form').click(function() {
		$('body').append('<div class="modal"><div class="loader"></div></div>');
		var theme = $(this).data('theme');
		var file = 'ajax-ask-form.php';
		var modal = $('div.modal');
		modal.css({visibility: 'visible'}).animate({opacity: 1}, 400, function() {
			$('<div>').load('/wp-content/themes/' + theme + '/' + file, function(html) {
				modal
					.empty()
					.append('<div class="modal-form  ask-form">' + html + '</div>');
				var $form = modal.find('form');
				wpcf7.initForm( $form );
				if ( wpcf7.cached ) wpcf7.refill( $form );
				$('div.ask-form input[type="file"]').wrap('<div class="ask-form__file"></div>').after('<div class="ask-form__file-name" data-text="Прикрепите файл">Прикрепите файл</div>');
			});
		});
	});

	$('body')
		.on('click', 'div.modal', function() {
			$('div.modal').fadeOut(function() {
				$(this).remove();
			});
		})
		.on('click', 'div.modal-form', function(e) {
			e.stopPropagation();
		})
	;

	$('body').on('change', 'div.ask-form__file input[type="file"]', function() {
		var el = $(this);
		var value = el.val();
		var name = el.closest('div.ask-form__file').find('div.ask-form__file-name');
		var placeholder = name.data('text');
		name.text(value.replace(/.+[\\\/]/, '')).addClass('changed');
		if (value === '') {
			name.text(placeholder).removeClass('changed');
		}
	});

	// ajax posts
	if ( $('div.more').length ) {
		$('body').on('click', 'div.more__button:not(.loading)', function() {
			var more = $(this);
			var container = $(this).closest('div.more').prev('div.ajax-items');
			var defaultText = more.html();
			var offset = more.data('offset');
			var items = more.data('items');
			var max = more.data('max');
			var theme = more.data('theme');
			var query = 'offset=' + offset + '&items=' + items;
			if (more.data('cat')) query = query + '&cat=' + more.data('cat');
			if (more.data('search')) query = query + '&s=' + more.data('search');
			more.addClass('loading').text( more.data('loading') );
			$.ajax({
				url: '/wp-content/themes/' + theme + '/ajax-posts.php?' + query
			}).done(function(html) {
				container.append(html);
				more.data('offset', offset + items).removeClass('loading').html(defaultText);
				$('html, body').animate({scrollTop: $('div.ajax-items .js-item-scroll-to:last()').offset().top - 30 }, 700);
				if ( more.data('offset') >= max ) more.parent().remove();
			});
		});
	}

});
})(jQuery);





//Пагинация добавить еще записи
jQuery(document).on('click', '.city__more a', function () { 
    
    
 
 var scrollPosition = [
  self.pageXOffset || document.documentElement.scrollLeft || document.body.scrollLeft,
  self.pageYOffset || document.documentElement.scrollTop  || document.body.scrollTop
];
var html = jQuery('html'); // it would make more sense to apply this to body, but IE7 won't have that
html.data('scroll-position', scrollPosition);
html.data('previous-overflow', html.css('overflow'));
//html.css('overflow', 'hidden');
window.scrollTo(scrollPosition[0], scrollPosition[1]);



var obj = jQuery(this);
var pageall = obj.data('allpage')*1;
var page = (1*obj.attr('data-page')+1);




if (page>=pageall) obj.parent().hide();
else obj.parent().show();


var city = obj.data('city');
var service = obj.data('service');
var limit = obj.data('limit');
  
  var vilial = obj.data('vilial')*1;
  var vilial_post_name = obj.data('vilial_post_name');
  var vilial_post_title = obj.data('vilial_post_title');



 
 jQuery('.company-list').css('opacity',0.6);
 obj.addClass('active');
 


 var formData ='&page='+page;
  formData +='&city='+city;
  formData +='&service='+service; 
  formData +='&limit='+limit;
  formData +='&vilial='+vilial;
  formData +='&vilial_post_name='+vilial_post_name;
  formData +='&vilial_post_title='+vilial_post_title;
  


  formData +='&action=agregator_navkomp';

 
  jQuery.ajax({
      url:ajax_url_web,
      type:'POST',
      data:formData,
      dataType: "json",  
      success: function(rec){

  var rec = rec.data;
  var html = rec.html;
   
    jQuery('.company-list').css('opacity',1);
    obj.removeClass('active');
  
   jQuery('.company-list').append(html);
   obj.attr('data-page',page);
 
 // un-lock scroll position
var html = jQuery('html');
var scrollPosition = html.data('scroll-position');
//html.css('overflow', html.data('previous-overflow'));
window.scrollTo(scrollPosition[0], scrollPosition[1])
 
  
    } 
 });


  return false;
  });

